/*import csv file*/
proc import datafile="R:\teaching\short course\missing data\session2\Empirical study\outdat.csv" 
out=indat dbms=csv replace; 
getnames=yes; 
run;

proc contents data=indat;
run;

/*create missing values*/
data indat2;
set indat;
if r=1 then Y=BPXSY1;
else Y=.;
Y_I=Y;
run;

/*Multiple imputation*/
proc mi nimpute=5 seed=74970 simple round=1 data=indat2 out=indat_mi;
var X1 X2 Y_I;
monotone reg(Y_I=X1 X2);
run;

/*Inference*/
proc univariate data=indat_mi noprint;
      var Y_I;
      output out=outuni mean=m_Y_I
                        stderr=S_Y_I;
      by _Imputation_;
   run;

 proc mianalyze data=outuni edf=7103;
      modeleffects m_Y_I;
      stderr S_Y_I;
   run;

/*Hotdeck imputation*/

/*Create cells*/
proc means min P25 P50 P75 max maxdec=2 data=indat2;
var X1 X2;
run;

data indat3;
set indat2;
if X1<=-0.94 then C1=1;
else if X1<=-0.07 then C1=2;
else if X1<=0.84 then C1=3;
else C1=4;

if X2<=-0.70 then C2=1;
else if X2<=-0.13 then C2=2;
else if X2<=0.54 then C2=3;
else C2=4;
run;

proc surveyimpute data=indat3 method=HD(selection=SRSWR) NDONORS=1 seed=6786 varmethod=jackknife;
cells C1 C2;
var Y_I;
output out=outdat outjkcoefs=out_JKCoefs;
run;

proc means mean P50 data=outdat;
var Y_I;
run;

